<template>
  <!--
     1.  이벤트와 함수를 연결하는 v-on입니다.
     2.  keyup 이벤트를 수식자와 함께 함수와 연결합니다.
         v-on:keyup.enter : enter를 눌렀을 때 이벤트 실행
         v-on:keyup.tab   : tab을 눌렀을 때 이벤트 실행
  -->

  <div class="container">
    <h2>서적 주문 양식</h2>
    <form method="get" v-on:input="update" @submit.prevent="submit">
      <!-- 입력할 때 마다 변경됩니다. -->
      <table class="table table-stripped">
        <tr>
          <th>책 제목</th>
          <th>가격</th>
          <th>수량</th>
          <th>합계</th>
        </tr>
        <tr>
          <td>4차 산업</td>
          <td>{{ price1.toLocaleString() }}원</td>
          <td>
            <input
              name="book1"
              type="text"
              size="2"
              v-model.number="count1"
              @focus="clear"
            />
          </td>
          <td>
            <span>{{ row_total1.toLocaleString() }}</span
            >원
          </td>
        </tr>
        <tr>
          <td>다이어트</td>
          <td>{{ price2.toLocaleString() }}원</td>
          <td>
            <input
              name="book2"
              type="text"
              size="2"
              v-model.number="count2"
              @focus="clear"
            />
          </td>
          <td>
            <span>{{ row_total2.toLocaleString() }}</span
            >원
          </td>
        </tr>
        <tr>
          <td>윤식당</td>
          <td>{{ price3.toLocaleString() }}원</td>
          <td>
            <input
              name="book3"
              type="text"
              size="2"
              v-model.number="count3"
              @focus="clear"
            />
          </td>
          <td>
            <span>{{ row_total3.toLocaleString() }}</span
            >원
          </td>
        </tr>
        <tr>
          <td>합계</td>
          <td>&nbsp;</td>
          <td>{{ total_count }}권</td>
          <td>{{ total_price.toLocaleString() }}원</td>
        </tr>
      </table>
      <br />

      <button class="btn btn-info" type="submit">제출</button>
    </form>

    <modal v-if="showModal" @close="showModal = false">
      <h3 slot="header">총 가격</h3>
      <span slot="footer" @click="showModal = false"
        >{{total_price.toLocaleString()}}원
        <i class="closeModalBtn fa fa-times" aria-hidden="true"></i>
      </span>
    </modal>
  </div>
</template>

<script>
import Modal from "../components/others-todo/common/Modal.vue";

export default {
	name: "Book",
	data() {
		return {
			price1: 300,
			count1: 0,
			price2: 2700,
			count2: 0,
			price3: 2500,
			count3: 0,
			row_total1: 0,
			row_total2: 0,
			row_total3: 0,
			total_count: 0,
			total_price: 0,
			showModal: false
		};
	},
	methods: {
		update() {
			this.row_total1 = this.price1 * this.count1;
			this.row_total2 = this.price2 * this.count2;
			this.row_total3 = this.price3 * this.count3;

			//v-model.number를 사용하면 parseInt()사용하지 않아도 됩니다.
			this.total_price = this.row_total1 + this.row_total2 + this.row_total3;
			//total_count.value = parseInt(count1.value) + parseInt(count2.value) +  parseInt(count3.value);

			//v-model.number를 사용하면 parseInt()사용하지 않아도 됩니다.
			this.total_count = this.count1 + this.count2 + this.count3;
		},
		clear(event) {
			//input에 focus를 주면 값을 초기화 합니다.
			//이벤트 발생시 event 객체를 받아 올 수 있습니다.
			event.target.value = "";
		},
		submit() {
			this.showModal = true;
		},
	},
	components: {
		Modal: Modal,
	},
};
</script>

<style scoped>
	* {
		text-align: center;
	}
	td:first-child {
		width: 25%;
	}
	td:nth-child(2) {
		width: 25%;
	}
	td:last-child {
		width: 25%;
		text-align: right;
	}
	td:first-child {
		background-color: yellow;
	}
	tr:last-child {
		background-color: greenyellow;
	}
	tr:last-child > td:first-child {
		background-color: white;
	}
	h2 {
		color: green;
		font-weight: bold;
		margin-top: 2em;
	}
</style>
